#ifndef _LORA_E32_H_
#define _LORA_E32_H_
#include <stdint.h>
#include <Arduino.h>

typedef enum
{
    U_8N1 = (0<<6),
    U_8O1 = (1<<6),
    U_8E1 = (2<<6)
}UParery_t;


typedef enum
{
    U_1200   = (0<<3),
    U_2400   = (1<<3),
    U_4800   = (2<<3),
    U_9600   = (3<<3),
    U_19200  = (4<<3),
    U_38400  = (5<<3),
    U_57600  = (6<<3),
    U_115200 = (7<<3)
}Ubaud_t;



typedef enum
{
    U_0_3Kbps  = 0,
    U_1_2Kbps  = 1,
    U_2_4Kbps  = 2,
    U_4_8Kbps  = 3,
    U_9_6Kbps  = 4,
    U_19_2Kbps = 5

}Ubitrate_t;



/*  OPTIONS  */

typedef enum{
    M_Transparent_Mode = (0<<7),
    M_Fixed_Mode       = (1<<7)
} Mode_t;

typedef enum{
    IO_PushPull  = (1<<6),
    IO_OpenDrain = (0<<6)
}IO_Mode_t;

typedef enum{
    W_250ms  = (0<<3),
    W_500ms  = (1<<3),
    W_750ms  = (2<<3),
    W_1000ms = (3<<3),
    W_1250ms = (4<<3),
    W_1500ms = (5<<3),
    W_1750ms = (6<<3),
    W_2000ms = (7<<3)
} WOR_Timing_t;

typedef enum{
    FEC_ON  = (1<<2),
    FEC_OFF = (0<<2)
} FEC_T;


typedef enum{
    T_30dBm = 0,
    T_27dBm = 1,
    T_24dBm = 2,
    T_21dBm = 3
}T_Power;


typedef struct
{
    uint16_t address;
    UParery_t parety;
    Ubaud_t   baud;
    Ubitrate_t bitrate;
    uint8_t channel;
    Mode_t mode;
    IO_Mode_t IO_Mode;
    WOR_Timing_t WOR_Timing;
    FEC_T FEC_SWITCH;
    T_Power Transmittion_Power;


}Uconfig;

//Methodes
void Dosetting(int M0, int M1, Uconfig *conf);
void E32SettingMode(int M0, int M1);
void E32FunctionMode(int M0, int M1);

#endif // _LORA_E32_H_
